const int OV7670_I2C_ADDR  = 0x42;

const int REG_GAIN         = 0x00;    // Gain lower 8 bits (rest in vref)
const int REG_BLUE         = 0x01;    // blue gain
const int REG_RED          = 0x02;    // red gain
const int REG_VREF         = 0x03;    // Pieces of GAIN, VSTART, VSTOP
const int REG_COM1         = 0x04;    // Control 1
const int   COM1_CCIR656   = 0x40; // CCIR656 enable
const int REG_BAVE         = 0x05;    // U/B Average level
const int REG_GbAVE        = 0x06;    // Y/Gb Average level
const int REG_AECHH        = 0x07;    // AEC MS 5 bits
const int REG_RAVE         = 0x08;    // V/R Average level
const int REG_COM2         = 0x09;    // Control 2
const int   COM2_SSLEEP     = 0x10; // Soft sleep mode
const int REG_PID          = 0x0a;    // Product ID MSB
const int REG_VER          = 0x0b;    // Product ID LSB
const int REG_COM3         = 0x0c;    // Control 3
const int   COM3_SWAP      = 0x40;    // Byte swap
const int   COM3_SCALEEN   = 0x08;    // Enable scaling
const int   COM3_DCWEN     = 0x04;    // Enable downsamp/crop/window
const int REG_COM4         = 0x0d;    // Control 4
const int REG_COM5         = 0x0e;    // All "reserved"
const int REG_COM6         = 0x0f;    // Control 6
const int REG_AECH         = 0x10;    // More bits of AEC value
const int REG_CLKRC        = 0x11;    // Clocl control
const int   CLK_EXT        = 0x40;    // Use external clock directly
const int   CLK_SCALE      = 0x3f;    // Mask for internal clock scale
const int REG_COM7         = 0x12;    // Control 7
const int   COM7_RESET     = 0x80;    // Register reset
const int   COM7_FMT_MASK  = 0x38;
const int   COM7_FMT_VGA   = 0x00;
const int   COM7_FMT_CIF   = 0x20;    // CIF format
const int   COM7_FMT_QVGA  = 0x10;    // QVGA format
const int   COM7_FMT_QCIF  = 0x08;    // QCIF format
const int   COM7_RGB       = 0x04;    // bits 0 and 2 - RGB format
const int   COM7_YUV       = 0x00;    // YUV
const int   COM7_BAYER     = 0x01;    // Bayer format
const int   COM7_PBAYER    = 0x05;    // "Processed bayer"
const int REG_COM8         = 0x13;    // Control 8
const int   COM8_FASTAEC   = 0x80;    // Enable fast AGC/AEC
const int   COM8_AECSTEP   = 0x40;    // Unlimited AEC step size
const int   COM8_BFILT     = 0x20;    // Band filter enable
const int   COM8_AGC       = 0x04;    // Auto gain enable
const int   COM8_AWB       = 0x02;    // White balance enable
const int   COM8_AEC       = 0x01;    // Auto exposure enable
const int REG_COM9         = 0x14;    // Control 9  - gain ceiling
const int   COM9_AGC_2X    = 0x00;
const int   COM9_AGC_4X    = 0x10;
const int   COM9_AGC_8X    = 0x20;
const int   COM9_AGC_16X   = 0x30;
const int   COM9_AGC_32X   = 0x40;
const int   COM9_AGC_64X   = 0x50;
const int   COM9_AGC_128X  = 0x60;
const int   COM9_AGC_MASK  = 0x70;
const int   COM9_FREEZE    = 0x01;
const int REG_COM10        = 0x15;    // Control 10
const int   COM10_HSYNC    = 0x40;    // HSYNC instead of HREF
const int   COM10_PCLK_HB  = 0x20;    // Suppress PCLK on horiz blank
const int   COM10_HREF_REV = 0x08;    // Reverse HREF
const int   COM10_VS_LEAD  = 0x04;    // VSYNC on clock leading edge
const int   COM10_VS_NEG   = 0x02;    // VSYNC negative
const int   COM10_HS_NEG   = 0x01;    // HSYNC negative
const int REG_HSTART       = 0x17;    // Horiz start high bits
const int REG_HSTOP        = 0x18;    // Horiz stop high bits
const int REG_VSTART       = 0x19;    // Vert start high bits
const int REG_VSTOP        = 0x1a;    // Vert stop high bits
const int REG_PSHFT        = 0x1b;    // Pixel delay after HREF
const int REG_MIDH         = 0x1c;    // Manuf. ID high
const int REG_MIDL         = 0x1d;    // Manuf. ID low
const int REG_MVFP         = 0x1e;    // Mirror / vflip
const int   MVFP_MIRROR    = 0x20;    // Mirror image
const int   MVFP_FLIP      = 0x10;    // Vertical flip
const int REG_AEW          = 0x24;    // AGC upper limit
const int REG_AEB          = 0x25;    // AGC lower limit
const int REG_VPT          = 0x26;    // AGC/AEC fast mode op region
const int REG_HSYST        = 0x30;    // HSYNC rising edge delay
const int REG_HSYEN        = 0x31;    // HSYNC falling edge delay
const int REG_HREF         = 0x32;    // HREF pieces
const int REG_TSLB         = 0x3a;    // lots of stuff
const int   TSLB_YLAST     = 0x04;    // UYVY or VYUY - see com13
const int REG_COM11        = 0x3b;    // Control 11
const int   COM11_NIGHT    = 0x80;    // NIght mode enable
const int   COM11_NMFR     = 0x60;    // Two bit NM frame rate
const int   COM11_HZAUTO   = 0x10;    // Auto detect 50/60 Hz
const int   COM11_50HZ     = 0x08;    // Manual 50Hz select
const int   COM11_EXP      = 0x02;
const int REG_COM12        = 0x3c;    // Control 12
const int   COM12_HREF     = 0x80;    // HREF always
const int REG_COM13        = 0x3d;    // Control 13
const int   COM13_GAMMA    = 0x80;    // Gamma enable
const int   COM13_UVSAT    = 0x40;    // UV saturation auto adjustment
const int   COM13_UVSWAP   = 0x01;    // V before U - w/TSLB
const int REG_COM14        = 0x3e;    // Control 14
const int   COM14_DCWEN    = 0x10;    // DCW/PCLK-scale enable
const int REG_EDGE         = 0x3f;    // Edge enhancement factor
const int REG_COM15        = 0x40;    // Control 15
const int   COM15_R10F0    = 0x00;    // Data range 10 to F0
const int   COM15_R01FE    = 0x80;    //            01 to FE
const int   COM15_R00FF    = 0xc0;    //            00 to FF
const int   COM15_RGB565   = 0x10;    // RGB565 output
const int   COM15_RGB555   = 0x30;    // RGB555 output
const int REG_COM16        = 0x41;    // Control 16
const int   COM16_AWBGAIN  = 0x08;    // AWB gain enable
const int REG_COM17        = 0x42;    // Control 17
const int   COM17_AECWIN   = 0xc0;    // AEC window - must match COM4
const int   COM17_CBAR     = 0x08;    // DSP Color bar

const int REG_CMATRIX_BASE = 0x4f;
const int   CMATRIX_LEN    = 6;
const int REG_CMATRIX_SIGN = 0x58;
const int REG_BRIGHT       = 0x55;    // Brightness
const int REG_CONTRAS      = 0x56;    // Contrast control
const int REG_GFIX         = 0x69;    // Fix gain control
const int REG_REG76        = 0x76;    // OV's name
const int   R76_BLKPCOR    = 0x80;    // Black pixel correction enable
const int   R76_WHTPCOR    = 0x40;    // White pixel correction enable
const int REG_RGB444       = 0x8c;    // RGB 444 control
const int   R444_ENABLE    = 0x02;    // Turn on RGB444, overrides 5x5
const int   R444_RGBX      = 0x01;    // Empty nibble at end
const int REG_HAECC1       = 0x9f;    // Hist AEC/AGC control 1
const int REG_HAECC2       = 0xa0;    // Hist AEC/AGC control 2

const int REG_BD50MAX      = 0xa5;    // 50hz banding step limit
const int REG_HAECC3       = 0xa6;    // Hist AEC/AGC control 3
const int REG_HAECC4       = 0xa7;    // Hist AEC/AGC control 4
const int REG_HAECC5       = 0xa8;    // Hist AEC/AGC control 5
const int REG_HAECC6       = 0xa9;    // Hist AEC/AGC control 6
const int REG_HAECC7       = 0xaa;    // Hist AEC/AGC control 7
const int REG_BD60MAX      = 0xab;    // 60hz banding step limit

int RESERVED_PATTERN[] = {
  0x00, // 00
  0x00, // 01
  0x00, // 02
  0x30, // 03 [5:4]
  0xbc, // 04 [7], [5:2]
  0x00, // 05
  0x00, // 06
  0xC0, // 07 [7:6]
  0x00, // 08
  0xec, // 09 [7:5] [3:2]
  0xFF, // 0a read-only 
  0xFF, // 0b read-only
  0x83, // 0c [7] [1:0]
  0xcf, // 0d [7:6] [3:0]
  0xff, // 0e [7:0]
  0x7d, // 0f [6:2] [0]
  0x00, // 10
  0x80, // 11 [7]
  0x40, // 12 [6]
  0x18, // 13 [4:3]
  0x8e, // 14 [7] [3:1]
  0x80, // 15 [7]
  0xFF, // 16 [7:0]
  0x00, // 17
  0x00, // 18
  0x00, // 19
  0x00, // 1a
  0x00, // 1b
  0xFF, // 1c read-only
  0xFF, // 1d read-only
  0xcb, // 1e [7:6] [3] [1:0]
  0xff, // 1f [7:0]
  0xf0, // 20 [7:4]
  0xff, // 21 [7:0]
  0xff, // 22 [7:0]
  0xff, // 23 [7:0]
  0x00, // 24
  0x00, // 25
  0x00, // 26
  0x00, // 27
  0x00, // 28
  0xff, // 29 [7:0]
  0x00, // 2a
  0x00, // 2b
  0x00, // 2c
  0x00, // 2d
  0x00, // 2e
  0x00, // 2f
  0x00, // 30
  0x00, // 31
  0x00, // 32
  0xff, // 33 [7:0]
  0xff, // 34 [7:0]
  0xff, // 35 [7:0]
  0xff, // 36 [7:0]
  0xff, // 37 [7:0]
  0xff, // 38 [7:0]
  0xff, // 39 [7:0]
  0xc6, // 3a [7:6] [2:1]
  0x05, // 3b [2] [0]
  0x7f, // 3c [6:0]
  0x3e, // 3d [5:1]
  0xe0, // 3e [7:5]
  0xe0, // 3f [7:5]
  0x0F, // 40 [3:0]
  0xc5, // 41 [7:6] [2] [0]
  0x37, // 42 [5:4] [2:0]
  0xff, // 43 reserved
  0xff, // 44 reserved
  0xff, // 45 reserved
  0xff, // 46 reserved
  0xff, // 47 reserved
  0xff, // 48 reserved
  0xff, // 49 reserved
  0xff, // 4a reserved
  0xfe, // 4b [7:1]
  0x00, // 4c
  0xff, // 4d
  0xff, // 4e
  0x00, // 4f
  0x00, // 50
  0x00, // 51
  0x00, // 52
  0x00, // 53
  0x00, // 54
  0x00, // 55
  0x00, // 56
  0x00, // 57
  0x40, // 58
  0xff, // 59
  0xff, // 5a
  0xff, // 5b
  0xff, // 5c
  0xff, // 5d
  0xff, // 5e
  0xff, // 5f
  0xff, // 60
  0xff, // 61
  0x00, // 62
  0x00, // 63
  0x00, // 64
  0x00, // 65
  0xfa, // 66 [7:3] [1]
  0x00, // 67
  0x00, // 68
  0x00, // 69
  0x00, // 6a
  0x2f, // 6b [5] [3:0]
  0x00, // 6c
  0x00, // 6d
  0x00, // 6e
  0x00, // 6f
  0x00, // 70
  0x00, // 71
  0x00, // 72
  0xf0, // 73 [7:4]
  0xec, // 74 [7:5] [3:2]
  0xe0, // 75 [7:5]
  0x20, // 76 [5]
  0x00, // 77
  0xff, // 78 reserved
  0xff, // 79 reserved
  0x00, // 7a
  0x00, // 7b
  0x00, // 7c
  0x00, // 7d
  0x00, // 7e
  0x00, // 7f
  0x00, // 80
  0x00, // 81
  0x00, // 82
  0x00, // 83
  0x00, // 84
  0x00, // 85
  0x00, // 86
  0x00, // 87
  0x00, // 88
  0x00, // 89
  0xff, // 8a
  0xff, // 8b
  0xfc, // 8c [7:2]
  0xff, // 8d reserved
  0xff, // 8e reserved
  0xff, // 8f reserved
  0xff, // 90 reserved
  0xff, // 91 reserved
  0x00, // 92
  0x00, // 93
  0x00, // 94
  0x00, // 95
  0xff, // 96 reserved
  0xff, // 97 reserved
  0xff, // 98 reserved
  0xff, // 99 reserved
  0xff, // 9a reserved
  0xff, // 9b reserved
  0xff, // 9c reserved
  0x00, // 9d
  0x00, // 9e
  0x00, // 9f
  0x00, // a0
  0xff, // a1 reserved
  0x80, // a2
  0xff, // a3 reserved
  0xf4, // a4 [7:4] [2]
  0x00, // a5
  0x00, // a6
  0x00, // a7
  0x00, // a8
  0x00, // a9
  0x7f, // aa [6:0]
  0x00, // ab
  0x0c, // ac [3:2]
  0x00, // ad
  0x00, // ae
  0x00, // af
  0xff, // b0 reserved
  0xfb, // b1 [7:3] [1:0]
  0xff, // b2 reserved
  0x00, // b3
  0xff, // b4 reserved
  0x00, // b5
  0xff, // b6 reserved
  0xff, // b7 reserved
  0xff, // b8 reserved
  0xff, // b9 reserved
  0xff, // ba reserved
  0xff, // bb reserved
  0xff, // bc reserved
  0xff, // bd reserved
  0x80, // be [7]
  0x80, // bf [7]
  0x80, // c0
  0x80, // c1
  0xff, // c2 reserved
  0xff, // c3 reserved
  0xff, // c4 reserved
  0xff, // c5 reserved
  0xff, // c6 reserved
  0xff, // c7 reserved
  0xff, // c8 reserved
  0x00 // c9
};


int default_register_values[][2] = {
  //// [REG_COM7, COM7_RESET], // reset is treated as special manner

  // Clock scale: 3 = 15fps
  //              2 = 20fps
  //              1 = 30fps
  {REG_CLKRC, 0x01},  // OV: clock scale (30 fps)
  {REG_TSLB,  0x04},  // OV
  {REG_COM7,  0x00},  // VGA

  // Set the hardware window.  These values from OV don't entirely
  // make sense - hstop is less than hstart.  But they work...

  {REG_HSTART, 0x13},
  {REG_HSTOP, 0x01},
  {REG_HREF, 0xb6},
  {REG_VSTART, 0x02},
  {REG_VSTOP, 0x7a},
  {REG_VREF, 0x0a},

  {REG_COM3, 0},
  {REG_COM14, 0},
  // Mystery scaling numbers
  {0x70, 0x3a},
  {0x71, 0x35},
  {0x72, 0x11},
  {0x73, 0xf0},
  {0xa2, 0x02},
  {REG_COM10, 0x0},

  // Gamma curve values
  //  {0x7a, 0x20},
  //  {0x7b, 0x10},
  //  {0x7c, 0x1e},
  //  {0x7d, 0x35},
  //  {0x7e, 0x5a},
  //  {0x7f, 0x69},
  //  {0x80, 0x76},
  //  {0x81, 0x80},
  //  {0x82, 0x88},
  //  {0x83, 0x8f},
  //  {0x84, 0x96},
  //  {0x85, 0xa3},
  //  {0x86, 0xaf},
  //  {0x87, 0xc4},
  //  {0x88, 0xd7},
  //  {0x89, 0xe8},

  {0x7a, 0x20},
  {0x7b, 0x1c},
  {0x7c, 0x28},
  {0x7d, 0x3c},
  {0x7e, 0x55},
  {0x7f, 0x68},
  {0x80, 0x76},
  {0x81, 0x80},
  {0x82, 0x88},
  {0x83, 0x8f},
  {0x84, 0x96},
  {0x85, 0xa3},
  {0x86, 0xaf},
  {0x87, 0xc4},
  {0x88, 0xd7},
  {0x89, 0xe8},

  // AGC and AEC parameters.  Note we start by disabling those features,
  //   then turn them only after tweaking the values.
  {REG_COM8, COM8_FASTAEC | COM8_AECSTEP | COM8_BFILT},
  {REG_GAIN, 0},
  {REG_AECH, 0},
  {REG_COM4, 0x40}, // magic reserved bit
  {REG_COM9, 0x18}, // 4x gain + magic rsvd bit
  {REG_BD50MAX, 0x05},
  {REG_BD60MAX, 0x07},
  {REG_AEW, 0x95},
  {REG_AEB, 0x33},
  {REG_VPT, 0xe3},
  {REG_HAECC1, 0x78},
  {REG_HAECC2, 0x68},
  {0xa1, 0x03}, // magic
  {REG_HAECC3, 0xd8},
  {REG_HAECC4, 0xd8},
  {REG_HAECC5, 0xf0},
  {REG_HAECC6, 0x90},
  {REG_HAECC7, 0x94},
  //{REG_COM8, COM8_FASTAEC|COM8_AECSTEP|COM8_BFILT|COM8_AGC|COM8_AEC},
  {REG_COM8, COM8_FASTAEC|COM8_AECSTEP|COM8_BFILT|COM8_AGC|COM8_AWB|COM8_AEC},

  // Almost all of these are magic "reserved" values.
  {REG_COM5, 0x61},
  {REG_COM6, 0x4b},
  {0x16, 0x02},
  {REG_MVFP, 0x37}, //{REG_MVFP, 0x07},
  {0x21, 0x02},
  {0x22, 0x91},
  {0x29, 0x07},
  {0x33, 0x0b},
  {0x35, 0x0b},
  {0x37, 0x1d},
  {0x38, 0x71},
  {0x39, 0x2a},
  {REG_COM12, 0x78},
  {0x4d, 0x40},
  {0x4e, 0x20},
  {REG_GFIX, 0},
  {0x6b, 0x4a},
  {0x74, 0x10},
  {0x8d, 0x4f},
  {0x8e, 0},
  {0x8f, 0},
  {0x90, 0},
  {0x91, 0},
  {0x96, 0},
  {0x9a, 0},
  {0xb0, 0x84},
  {0xb1, 0x0c},
  {0xb2, 0x0e},
  {0xb3, 0x82},
  {0xb8, 0x0a},

  // More reserved magic, some of which tweaks white balance
  {0x43, 0x0a},
  {0x44, 0xf0},
  {0x45, 0x34},
  {0x46, 0x58},
  {0x47, 0x28},
  {0x48, 0x3a},
  {0x59, 0x88},
  {0x5a, 0x88},
  {0x5b, 0x44},
  {0x5c, 0x67},
  {0x5d, 0x49},
  {0x5e, 0x0e},
  {0x6c, 0x0a},
  {0x6d, 0x55},
  {0x6e, 0x11},
  {0x6f, 0x9f}, // "9e for advance AWB"
  {0x6a, 0x40},
  {REG_BLUE, 0x40},
  {REG_RED, 0x60},
  {REG_COM8, COM8_FASTAEC|COM8_AECSTEP|COM8_BFILT|COM8_AGC|COM8_AEC|COM8_AWB},

  // Matrix coefficients
  {0x4f, 0x80},
  {0x50, 0x80},
  {0x51, 0},
  {0x52, 0x22},
  {0x53, 0x5e},
  {0x54, 0x80},
  {0x58, 0x9e},

  {REG_COM16, COM16_AWBGAIN},
  {REG_EDGE, 0},
  {0x75, 0x05},
  {0x76, 0xe1},
  {0x4c, 0},
  {0x77, 0x01},
  {REG_COM13, 0xc3},
  {0x4b, 0x09},
  {0xc9, 0x60},
  {REG_COM16, 0x38},
  {0x56, 0x40},

  {0x34, 0x11},
  {REG_COM11, COM11_EXP|COM11_HZAUTO},
  {0xa4, 0x88},
  {0x96, 0},
  {0x97, 0x30},
  {0x98, 0x20},
  {0x99, 0x30},
  {0x9a, 0x84},
  {0x9b, 0x29},
  {0x9c, 0x03},
  {0x9d, 0x4c},
  {0x9e, 0x3f},
  {0x78, 0x04},

  // Extra-weird stuff.  Some sort of multiplexor register
  {0x79, 0x01},
  {0xc8, 0xf0},
  {0x79, 0x0f},
  {0xc8, 0x00},
  {0x79, 0x10},
  {0xc8, 0x7e},
  {0x79, 0x0a},
  {0xc8, 0x80},
  {0x79, 0x0b},
  {0xc8, 0x01},
  {0x79, 0x0c},
  {0xc8, 0x0f},
  {0x79, 0x0d},
  {0xc8, 0x20},
  {0x79, 0x09},
  {0xc8, 0x80},
  {0x79, 0x02},
  {0xc8, 0xc0},
  {0x79, 0x03},
  {0xc8, 0x40},
  {0x79, 0x05},
  {0xc8, 0x30},
  {0x79, 0x26}
};

int rgb565_values[][2] = {
  {REG_COM7, COM7_RGB}, // Selects RGB mode
  {REG_RGB444, 0},      // No RGB444 please
  {REG_COM1, 0x0},
  {REG_COM15, COM15_RGB565},
  {REG_COM9, 0x38},     // 16x gain ceiling; 0x8 is reserved bit
  {0x4f, 0xb3},         // "matrix coefficient 1"
  {0x50, 0xb3},         // "matrix coefficient 2"
  {0x51, 0x00},         // vb
  {0x52, 0x3d},         // "matrix coefficient 4"
  {0x53, 0xa7},         // "matrix coefficient 5"
  {0x54, 0xe4},         // "matrix coefficient 6"
  {REG_COM13, COM13_GAMMA|COM13_UVSAT}
};

int yuv422_values[][2] = {
  {REG_COM7, 0x0}, // Selects YUV mode
  {REG_RGB444, 0}, // No RGB444 please
  {REG_COM1, 0 },
  {REG_COM15, COM15_R00FF},
  {REG_COM9, 0x18}, // 4x gain ceiling; 0x8 is reserved bit
  {0x4f, 0x80},     // "matrix coefficient 1"
  {0x50, 0x80},     // "matrix coefficient 2"
  {0x51, 0},        // vb
  {0x52, 0x22},     // "matrix coefficient 4"
  {0x53, 0x5e},     // "matrix coefficient 5"
  {0x54, 0x80},     // "matrix coefficient 6"
  {REG_COM13, COM13_GAMMA|COM13_UVSAT}
};

int color_matrix_rgb565[][2] = {
  {0x4f, 0xb3},
  {0x50, 0xb3},
  {0x51, 0x00},
  {0x52, 0x3d},
  {0x53, 0xa7},
  {0x54, 0xe4},
  {0x58, 0x9e},
};

int color_matrix_yuv422[][2] = {
  {0x4f, 0x80},
  {0x50, 0x80},
  {0x51, 0x00},
  {0x52, 0x22},
  {0x53, 0x5e},
  {0x54, 0x80},
  {0x58, 0x9e},
};
